\documentclass[11pt, a4paper]{article}
\usepackage[utf8]{inputenc}
\usepackage[english]{babel}
\usepackage[left = 2cm,right = 2cm,top = 2cm,bottom = 3cm]{geometry}

\usepackage{amsmath}
\usepackage{amsfonts}
\usepackage{float}
\usepackage{graphicx}
\usepackage{multicol}
\usepackage{multirow}
\usepackage{units}
\usepackage{mwe}
\usepackage{graphbox}
\usepackage{verbatim}
\usepackage{fancyvrb}
\usepackage{array}
\usepackage{pdfpages}
\usepackage{booktabs}
\usepackage{setspace}
\usepackage{flafter}

\usepackage{report_pwr}

\title{Multi Mobile Robot System with a\\Centralized Controller}
\lecture{Intermediate Project}
\term{Tuesday 09:15 --- 11:00}
\author{\foreignlanguage{polish}{Jakub Kozłowicz}, 252865}
\lecturer{\foreignlanguage{polish}{Witold Paluszyński} PhD}
\date{October 2023}

\begin{document}

\maketitle
% \tableofcontents
% \pagebreak

\section{Project Description}

The project involves the implementation of a multi mobile robot system with a
centralized controller. The system consists of a virtual environment, mobile
robots and a centralized controller (see Fig.~\ref{fig:controller-diagram}). The
\begin{figure}[t!]
	\centering
	\includegraphics[width = 0.8\textwidth]{./images/controller-diagram.png}
	\caption{Diagram of the multi mobile robot system with a centralized controller.}%
	\label{fig:controller-diagram}
\end{figure}
virtual environment is a 3D simulation of a custom designed room with different
obstacles. The mobile robots are autonomous vehicles that can move in the
virtual environment. The centralized controller is a software that controls the
mobile robots in order to avoid collisions. The system is implemented in Python
programming language using ROS2 framework and Gazebo simulator. Additionally,
the system may be deployed on a real hardware.

\section{Project outcome}

The project outcome is a working 3D simulation of a multi mobile robot system
with a centralized controller. Also, the movement of the mobile robots is
smooth, and the collisions are avoided. The algorithm for the centralized
controller is designed in a way that it can be easily extended to work with
arbitrary number of mobile robots. Mobile robots in the system are controlled by
the Nav2 stack (for integration with hardware robots).

\section{Project Goals}

\begin{table}[H]
	\centering
	\caption{Project goals.}%
	\label{tab:goals}
	\begin{tabular}{p{0.7\textwidth}p{0.15\textwidth}} \toprule
		\textbf{Goal}                                           & \textbf{Priority} \\ \midrule
		Working simulation with two robots                      & Must have         \\ \midrule
		Proper control with two robots                          & Must have         \\ \midrule
		Working simulation with proper control of couple robots & Nice to have      \\ \midrule
		Working environment with hardware robots                & Nice to have      \\ \midrule
	\end{tabular}
\end{table}

\section{Tools and Technologies}

\begin{itemize}
	\item \textbf{Python} --- main programming language
	\item \textbf{PyCharm/VS Code} --- IDE
	\item \textbf{Git/GitLab} --- version control system
	\item \textbf{ROS2} --- Robot Operating System
	\item \textbf{Gazebo/rviz} --- 3D simulator/Visualizer
	\item \textbf{Docker} --- containerization platform (for deployment on real hardware)
\end{itemize}

\section{Main Risks and Challenges}

The project has several challenges. It involves the following risks and challenges:
\begin{enumerate}[noitemsep]
	\item \textbf{Integration Complexity} --- Integrating multiple components
	      like the virtual environment, mobile robots, and centralized
	      controller can be complex and may lead to compatibility issues.
	\item \textbf{Simulation vs. Real Hardware} --- Transitioning from a
	      simulation environment (Gazebo) to real hardware can be challenging.
	      What works in simulation may not work the same way in the real world.
	\item \textbf{Collision Avoidance} --- Ensuring collision avoidance among
	      multiple mobile robots can be difficult, especially when they operate
	      in a dynamic environment.
	\item \textbf{Scalability} --- Extending the system to work with an
	      arbitrary number of mobile robots may introduce scalability issues.
	\item \textbf{Hardware Integration} --- Integrating the centralized
	      controller with real hardware can pose challenges, including hardware
	      compatibility, latency, and sensor data processing.
	\item \textbf{Algorithm Development} --- Developing effective control
	      algorithms for the centralized controller can be time-consuming and
	      prone to errors.
\end{enumerate}

\nocite{Roszkowska:Makowski:Janiec:MlCMMRS:2023}
\nocite{Roszkowska:Jakubiak:CsMMRS:2021}
\nocite{ROS2:2022}
\nocite{Gazebo:2014}
\nocite{Rak:2022:TB2}
\nocite{Rak:2022:TB2_Nav2}

\bibliographystyle{abbrv}
\bibliography{references}

\end{document}
